

mov=aviread('foreman.avi');

Anchor_Img=mov(1).cdata;
Predict_Img=mov(2).cdata;

QP=input('Enter quantization factor (1 to 100):\n');
total_numt=size(Anchor_Img);
total_num=total_numt(1)*total_numt(2);

Qmatrix=ones(8,8)*QP;
%use a uniform qunatization matrix, scaled by QP
close all;

figure;
imshow(uint8(Predict_Img));
title('Original image');

Orig_dct=blkproc(Predict_Img,[8 8],'dct2');
%performing 2D DCT on each block of Anchor_Img
figure;
imshow(uint8(Orig_dct));
title('DCT of Original Image');


QOrig_dct=blkproc(Orig_dct,[8 8],'quan_dct',Qmatrix);
%performing "quan_dct" on each block of Orig_dct
%quan_dct is a function defined in a separate program. See quan_dct.m

%count the number of non-zero coefficients in QOrig_dct
num_zeros_QOrig=sum(sum(abs(QOrig_dct)>0));
fprintf('The percentage of non-zero DCT coefficients\n in original image:%f\n',num_zeros_QOrig/total_num);

figure;
imshow(uint8(QOrig_dct));
title('Quantized DCT of Original Image');

%perform inverse 2D DCT
Recon_image=blkproc(QOrig_dct,[8 8],'idct2');
figure;
imshow(uint8(Recon_image));
title('Reconstructed image from quantized DCT');


PSNR=10*log10(255*255/mean(mean(((Predict_Img-uint8(Recon_image)).^2))));
fprintf('The PSNR of the reconstructed image when DCT is applied to the original image:%f\n',PSNR);

%form the prediction error image
Err_Img=Predict_Img-Anchor_Img;

%apply previous processing on Err_image
figure;
imshow(uint8(Err_Img));
title('Original error image without quantization');

Err_dct=blkproc(Err_Img,[8 8],'dct2');

figure;
imshow(uint8(Err_dct));
title('DCT of the error image');

QErr_dct=blkproc(Err_dct,[8 8],'quan_dct',Qmatrix);
figure;
imshow(uint8(QErr_dct));
title('Quantized DCT of the error image');
num_zeros_QErr=sum(sum(abs(QErr_dct)>0));
fprintf('The percentage of non-zero DCT coefficients\n  in the error image:%f\n',num_zeros_QErr/total_num);

Recon_err_image=blkproc(QErr_dct,[8 8],'idct2');
figure;
imshow(uint8(Recon_err_image));
title('Reconstructed error image from quantized DCT');
figure;

Recon_image=Anchor_Img+uint8(Recon_err_image);
imshow(uint8(Recon_image));
title('Reconstructed image with prediction');
PSNR=10*log10(255*255/mean(mean(((Predict_Img-Recon_image).^2))));
fprintf('The PSNR of the reconstructed image when DCT is applied to the error image:%f\n',PSNR);
    

